# Things to go through in the workshop

- Brief discussion about best practices (I think this workshop is better framed as being about best practices for coding and that a git workflow is part of that) and hence we might cover:
  - Using git
  - Writing good code (modular, sef-documenting, following Schira-lab standards etc)
  - Writing [good commit messages](https://chris.beams.io/posts/git-commit/)
  - Having a code review process.
- Intro to git, played by ear depending on how familiar you guys are with git, but don't go beyond conceptual models (no commands). Discussion on git workflow could be done here but might also be better to wait to discussion on the structur of teh Schira-lab repo.
- git and gitlab set up, slog through this first that way we can learn the commands by doing (or we can organise to do it beforehand).
  - [Setup identity](https://git-scm.com/book/en/v2/Getting-Started-First-Time-Git-Setup) (name and email)
  - [Default editor](https://git-scm.com/book/en/v2/Getting-Started-First-Time-Git-Setup)
  - Gitlab registering if not already done
  - **(optional)**
  - [SSH keys](https://docs.gitlab.com/ce/ssh/README.html) for username and password-less pushing
  - [Git push default](https://stackoverflow.com/questions/948354/default-behavior-of-git-push-without-a-branch-specified#948397) behavior
- How to git (first with dumby files we make, but would  be good make some small improvements to existing scripts to get a feel for how code reviews might actually go down in the lab)
  - Pipeline for making changes (how to pull, status, diff, stage, commit and push)
  - Pipeline for branching (how to branch, checkout, push and gitlab-merge and code review).
  - Dealing with conflicts (pull conflict locally, resolve, commit push)
  - .gitignore (for some data and maybe other weird things output by MATLAB?)
  - **(bonus)**
  - using git stash
  - merging locally
- Discussion on editors and or git GUIs (ie what are the best git-related tools for Schira-lab)
- Discussion on the structure of the Schira-lab repo, coding best practices and developing your own standards for the lab, mlint
- Further reading
  - [Atlassian's free resources](https://www.atlassian.com/git)
  - Pro Git by Scott Chacon and Ben Straub
